console.log( "Scr.js loading.." );
/*	このコメントの最終更新日：19/05/20(月) 20:04:55

	Scr.js
	
		導入手順：
		
			対象HTMLに、以下を挿入。
				<script src="Scr.js"></script>

			onload時の実行などで以下を実行。
				scr = new Scr( function() {
					alert( "Hello world!" );
				} );
				scr.exec();
			
			すると、Hello world! とアラートが出る。
		
			
		対応内容：
			
			19/05/28(火) 22:17:39	if() 単文　に対応した。
			19/05/22(水) 21:03:36	else if に対応した。
			19/05/20(月) 20:52:21	if else に対応した。
			19/05/19(日) 17:43:59	.js外部ファイル化
			19/05/19(日) 17:43:02	関数ステップイン対応
				関数呼び出し時、関数名の後に _ を付けると、
				_ を付けていない関数をScrで実行する。
			19/05/19(日) 17:40:16	関数スコープ、ブロックスコープ対応
			19/05/19(日) 17:39:58	delay()関数作成
			19/05/19(日) 17:39:35	if, while, for対応
		
		
		非対応：
			
			19/05/22(水) 21:59:23	break, continue
			19/05/22(水) 21:59:02	for in
			19/05/22(水) 21:58:36	do..while
			19/05/22(水) 21:58:03	switch
			19/05/22(水) 21:55:43	do..until
*/

var cl = console.log;
var HereDocument = /[^]*\/\*\s([^]*)\*\/\}$/;
var FunctionCodeRE = /[^]*?\{\s([^]*)\}$/;

first = true;

//コンストラクタ
function Scr( arg ) {
		
	/*
	現在
		if( 改行 )		に非対応
		function() {}	に非対応
		if() func(); 	に非対応
	*/
	
		//check.	引数の種類によって初期化方法を分ける
		if( typeof arg === "object" ) {
		
			//objectが指定されたとき（制御文のブロックの実行のために呼ばれた場合）
			text = arg.block;
			this.selfBlock = arg;
			this.blockScope = new Object();
			this.functionScope = Scr.functionScopeStack[ Scr.functionScopeStack.length - 1 ];

		} else {
		
			//objectではないとき（メインプログラムの場合）
			if( typeof arg === "function" )
				text = arg.toString().match( FunctionCodeRE )[ 1 ];
			else
				text = arg;
			
			this.selfBlock = {
				typ	:	"main",
				ini	:	null,
				cnd	:	null,
				add	:	null,
			};
			this.blockScope = new Object();
			this.functionScope = this.blockScope;
			Scr.functionScopeStack.push( this.blockScope );
		}

	//textを整形
		
		//セミコロンで改行したいので、for文を退避
		var forEscapes;
		if( forEscapes = text.match( /for\([\s\S]*?;[\s\S]*?;[\s\S]*?\)/g ) ) {
			text = text.replace( /for\([\s\S]*?;[\s\S]*?;[\s\S]*?\)/g, "_forEscape_" );
		}
	
	//セミコロンで改行
	text = text.replace( /;/g, ";\n" );
		
		//退避したfor文を復帰
		if( forEscapes )
		for( var i = 0; i < forEscapes.length; i++ ) {
			text = text.replace( /_forEscape_/, forEscapes[ i ] );
		}
	
	//if() 単文　に対応
	/*
	if()の)を認知するとき、
	適当に if\(.*?\) にしてしまうと、()内の関数呼び出しなどで認知が不正になる。
	正しく認知させるために以下のように大きめになった。
	*/
	var tail = text;
		text = "";
	while( tail.match( /\b(if\(|else\s|while\(|for\()/ ) ) {
		text += RegExp.leftContext + RegExp.lastMatch;
		tail = RegExp.rightContext;
		
				//check.　ifやwhileなどは、条件部分をスキップする
				var isElse = RegExp.lastMatch.match( /^else\s$/ );

					//check.　elseで、else ifの場合はやりなおしてifを検知させる
					if( isElse && tail.match( /^\s*if\(/ ) ) continue;
				
				if( ! isElse ) {
					//ex. if( 'res[ 1 ]' ) 'res[ 2 ]'
					var res = Scr.getToPairBracket( tail );
					text += res[ 1 ] + ")";	
					tail = res[ 2 ].substr( 1 );
				}
		
		//ifやwhileに続く{}なしの命令文単文を{}付きに変換
		if( tail.match( /^\s*[^{\s].*;/ ) ) {
			tail = RegExp.rightContext;
			text += "{" + RegExp.lastMatch + "}";
		}
	}
	text += tail;
	
	text = text.replace( /[{}]/g, function( s ) { return "\n" + s + "\n" } );
	text = text.replace( /^\s+/mg, "" );
	text = text.replace( /\/\/.*$/gm, "" );
	text = text.replace( /\n$/, "" );		//最終行の改行除去

	//debug
	if( first ) {
		first = false;
		cl( "\n=====" + text.replace( /^/mg, "\t" ) + "\n====\n" );
	}

	this.lines = text.split( /\n/ );
		
	//全体制御用
	this.programCounter 	= 0;
	this.isEnd 				= false;
	this.isDelayed 			= false;
	
	//制御構文用
	this.subBlockLV 		= -1;
	this.subBlock 			= null;
	this.resultOfIf 		= null;
	this.isGettingSubBlock	= false;
	
}//class
Scr.getToPairBracket = function( string ) {
	var result = [
		string,	//もともとの文字列
		"",		//対応する閉じ括弧までの文字列（閉じ括弧を含まない）
		""		//対応する閉じ括弧以降の文字列（閉じ括弧を含む）
	];
	var tail = string;
	var level = 0;
	while( tail.match( /[\(\)]/ ) ) {
		result[ 1 ] += RegExp.leftContext;
		tail = RegExp.rightContext;
		var got = RegExp.lastMatch;
			//check.
			if( got == "(" ) {
				level++;
			} else {
				//got == ")"
				level--;
					//check.
					if( level == -1 ) {
						result[ 2 ] = got + tail;
						return result;
					}
			}
		result[ 1 ] += got;
	}
	return result;
}
Scr.prototype.execBlock = function( subBlock ) {
	//現在のプログラムを上位のブロックとして保管
	Scr.stack.push( this );
	//subBlockを下位ブロックとして実行
	scr = new Scr( subBlock );
		//※scrはグローバル
	setTimeout( scr.exec.bind( scr ), 0 );
}
Scr.prototype.eval = function( script ) {
	with( this.functionScope )
		with( this.blockScope )
			return eval( script );
}
Scr.prototype.exec = function() {
	/*	19/05/19(日) 17:47:01
	execメソッド：
	
		大きなwhileループがあり、そのあとに、ループをどのように抜けたかというチェックが２つ続いている。
		
		大きなwhileループは、基本的にプログラムの行を１行ずつ進める。
		大きなwhileループは、おおまかに３つの部分、
			プログラムカウンタを進める部分、
			if, while, for文等制御構文のブロック部分を取得する部分
			if, while, for文等制御構文や平文を識別する部分
		で構成されている。
		大きなwhileループのあとに続く、ループをどのように抜けたかという２つのチェックは
			プログラムの終了でループを抜けた場合
			delay命令でループを抜けた場合
		の２つであり、
		そのうちの１つ、プログラムの終了でループを抜けた場合は、
			ブロックが最後に到達し、ブロックから出る処理である。
			（stackに保管した親ブロックを取り出すというもの）
		もう１つの、delay命令でループを抜けた場合は、
			setTimeoutを使って100ms後に復帰するという処理である。
		
		execメソッドを実行すると、Scrが持つプログラムのソースコードをすべて実行することになる。
	*/
	
	while( ! this.isEnd ) {
		
			//check.	直前のif文が偽だったとき次のelseは有効。
			var isEnableElse = this.resultOfIf == false;
				this.resultOfIf = null;
		
		var line = this.lines[ this.programCounter ];
		
		//======プログラムカウンタを進める======
		this.programCounter ++;
		
			//check.	プログラム（ブロック）の末尾を超えた
			if( this.programCounter > this.lines.length ) {
				//終了、またはループ処理
				switch( this.selfBlock.typ ) {
					case "main":
					case "if":
					case "else":
					case "else if":
						//プログラム（ブロック）の終了
						this.isEnd = true;
						break;
					case "for":
						//for文 カウンタ変数の更新
						if( this.selfBlock.add ) this.eval( this.selfBlock.add );
						//breakせず下へつづく
					case "while":
						//ループの継続条件を評価（while,for共通　ループとして２回目以降）
						if( this.eval( this.selfBlock.cnd ) ) {
							//ループ継続
							this.programCounter = 0;
						} else {
							//ループ終了
							this.isEnd = true;
						}
						break;
				}
				continue;
			}//check.
		
		
		//======if, while, for文等制御構文のブロック部分を取得する======
		
		if( this.isGettingSubBlock ) {
			if( line == "{" ) {			//ブロック開始文字（入れ子の開始）
				this.subBlockLV ++;
			} else if( line == "}" ) {	//ブロック終了文字
				this.subBlockLV --;
					//check.	ブロック取得完了か
					if( this.subBlockLV == 0 ) {
						this.isGettingSubBlock = false;
						
						//for文 初期化実行
						if( this.subBlock.typ == "for" ) this.eval( this.subBlock.ini );

						//if,while,for共通　条件評価（ループとしては１回目となる）
							var subBlockIsIf = this.subBlock.typ.match( /^(?:if|else if)$/ );
						if( this.eval( this.subBlock.cnd ) ) {
							//ブロック内を実行
							if( subBlockIsIf ) this.resultOfIf = true;
							this.execBlock( this.subBlock );
							break;		//このwhileループは一時終了する（subBlock実行終了で再開する）
						} else {
							//ブロック内をスキップ
							if( subBlockIsIf ) this.resultOfIf = false;
							continue;	//次へ
						}
					}//if
			}//if
			
			//ブロック内の１行として取得
			this.subBlock.block += line + "\n";
			continue;	//ブロック取得中は以上を繰り返す
			
		}//if
		
		
		//======if, while, for文等制御構文や平文を識別する部分======
		
		if( line.match( /^delay\(/ ) ) {
		
			//同期命令はループを抜ける
			this.isDelayed = true;
			break;	//外側whileをbreak
			
		} else if( line.match( /^(if|while)\(([\s\S]*)\)/ ) ) {
		
			//if( cnd ), while( cnd )
			this.subBlock = {
				typ	:	RegExp.$1,
				cnd	:	RegExp.$2,
			}
			continue;	//次のループで、この下のほうの【ブロック開始文】が読まれるはず。
		
		} else if( line.match( /^for\(\s*([\s\S]*)\s*;\s*([\s\S]*)\s*;\s*([\s\S]*\s*)\)/ ) ) {
		
			//for( ini; cnd; add )
			this.subBlock = {
				typ	:	"for",
				ini	:	RegExp.$1,
				cnd	:	RegExp.$2,
				add	:	RegExp.$3,
			}

				//check.	for変数をグローバル変数にする
				if( this.subBlock.ini.match( /^var / ) ) {
					this.subBlock.ini = this.subBlock.ini.replace( /^var\s+/, "window." );
				} else {
					this.subBlock.ini = "window." + this.subBlock.ini;
				}
				this.subBlock.cnd = "window." + this.subBlock.cnd;
				this.subBlock.add = "window." + this.subBlock.add;

			continue;	//次のループで、この下のほうの【ブロック開始文】が読まれるはず。
		} else if( line.match( /^else\s+if\(([\s\S]*)\)/ ) ) {
			
			//else if( cnd )
			this.subBlock = {
				typ	:	"else if",
				cnd	:	isEnableElse.toString() + " && ( " + RegExp.$1 + ")",
			}
			continue;	//次のループで、この下のほうの【ブロック開始文】が読まれるはず。
			
		} else if( line.match( /^else\s*$/ ) ) {
			
			//else
			this.subBlock = {
				typ	:	"else",
				cnd	:	isEnableElse.toString(),
			}
			continue;	//次のループで、この下のほうの【ブロック開始文】が読まれるはず。

		} else if( line == "{" ) {
		
			//【ブロック開始文】
			this.subBlock.block		= "";
			this.subBlockLV 		= 1;
			this.isGettingSubBlock 	= true;
			continue;	//次のループから、ブロックの取得が始まる。
		
		} else {
			
			//平文（実行する）
			
			//平文内の関数を実行する
			line = line.replace( /;$/, "" );	//末尾；除去
			if( line.match( /^([a-z0-9$_\.]*_)\(([\s\S]*)\)$/ ) ) {
			
				//関数名末尾に _ が付与されている場合
				//関数の内容へステップインする
				var funcName	= RegExp.$1;
				var funcOpt 	= RegExp.$2;
					//check.	関数名末尾の _ を除去
					funcName 	= funcName.replace( /_$/, "" );
				cl( funcName );
				var source 		= window[ funcName ].toString().match( FunctionCodeRE )[ 1 ];
				this.execBlock( source );
				break;	//この処理（親プロセス）を一時的に終了へ
				
			} else {
				
				//関数定義
				var recursive = function( string ) {
						var right 	= string;
							string 	= "";
						//関数にマッチするあいだ
						while( right.match( /([a-z0-9$_\.]*)\(([\s\S]*)\)/ ) ) {
							var left 	= RegExp.leftContext;
								right 	= RegExp.rightContext;
							var center 	= RegExp.lastMatch;
							var funcName = RegExp.$1;
							var funcOpt	= RegExp.$2;
							//関数の引数部分について再帰処理
							string += left + this.eval( funcName + "(" + recursive( funcOpt ) + ")" );
						}
						string += right;
						return string;
				}.bind( this );
				
				var line2 = recursive( line );
					line2 = line2.replace( /^var\s+/, "scr.functionScope." );
					line2 = line2.replace( /^let\s+/, "scr.blockScope." );
				
				this.eval( line2 );
				
			}
		} //if
	}//while
		
	//プログラム（ブロック）の終了でループを抜けた場合
	if( this.isEnd ) {
		if( Scr.stack.length > 0 ) {
			//保管していた上位のブロックを取り出す
			scr = Scr.stack.pop();
			setTimeout( scr.exec.bind( scr ), 0 );
		} else {
			console.log( "all end." );
		}
		return;
	}
	
	//delay命令でループを抜けた場合
	if( this.isDelayed ) {
		this.isDelayed = false;
		this.timerID = setTimeout( function() { this.exec(); }.bind( this ), 100 );
		return;
	}
	
};//Scr.prototype.exec


//クラス変数

Scr.stack = new Array();
Scr.functionScopeStack = new Array();
