console.log( "effect.js loading.." );

effect = new Object();
addEventListener( "load", function() {
	//onload時の実行（初期化）
	this.name = "effect";
	this.preloaded = false;
	this.fade = false;
	this.fadeCnt = 0;
	this.beforeScene = null;
	this.preload1();
}.bind( effect ), false );

effect.preload1 = function() {
	console.log( "effect preload1()" );
	/*
		テキストデータで作ったパターンからfillStyle用のパターン画像を作りたい。
		
		1. テキストデータからImageDataを作成する。
		2. そのImageDataをCANVASに描画する。
		3. そのCANVASをtoDataURL()を使って、Imageにする。
		4. そのImageからcreatePattern()でfillStyle用のパターンにする。
		
		※テキストデータはプログラムの最後にあります。
		※ImageDataからcreatePattern()できれば良かったのですができなかったです。
	*/
	
	//裏画面で作業する
	var bc = document.getElementById( "backCanvas" ).getContext( "2d" );
		
	//1. テキストデータからImageDataを作成する。
	widthBak = bc.canvas.width;
	heightBak = bc.canvas.height;
	bc.canvas.width = 16;
	bc.canvas.height = 16;
	var dataURLs = new Array();
	//スクリーントーンそれぞれについて
	for( var i = 0; i < screenToneData.length; i++ ) {
		//oneScreenToneData -> ImageData
		var oneScreenToneData = screenToneData[ i ];
		var im = bc.createImageData( 4, 4 );
		for( var y = 0; y < 4; y++ ) {
			for( var x = 0; x < 4; x++ ) {
				var v = Number( oneScreenToneData[ y ].substr( x, 1 ) ) * 255;
				var p = ( y * 4 + x ) * 4;
				im.data[ p++ ] = v;	//R
				im.data[ p++ ] = v; //G
				im.data[ p++ ] = v; //B
				im.data[ p++ ] = v; //A
			}
		}
		//2. そのImageDataをCANVASに描画する。
		for( var y = 0; y < 4; y++ ) {
			for( var x = 0; x < 4; x++ ) {
				bc.putImageData( im, x * 4, y * 4 );
			}
		}
		//3. そのCANVASをtoDataURL()を使って、Imageにする。
		dataURLs.push( bc.canvas.toDataURL( 'image/png' ) );
	}
	
	//ImageのsrcにdataURLを代入するとすぐにcompleteしないのでプリロード処理する
	this.preloader = new Preloader( dataURLs, new Array() );
	this.preloader.onCompletex = this.onPreloadedx.bind( this );
	this.preloader.exec();
}

effect.onPreloadedx = function() {
	console.log( "effect onPreloadedx()" );
	/*
		パターンのImageが用意できたところで、
		それをcreatePatternする。
		準備処理終了をメインに知らせる。
	*/

	//裏画面で作業する
	var bc = document.getElementById( "backCanvas" ).getContext( "2d" );
	
	screenTones = new Array();
		//4. そのImageからcreatePattern()でfillStyle用のパターンにする。
		for( var i = 0; i < this.preloader.images.length; i++ ) {
			screenTones.push( bc.createPattern( this.preloader.images[ i ], "" ) );
		}

	bc.canvas.width = widthBak;
	bc.canvas.height = heightBak;
	
	//テスト描画
	if( 0 ) {
		for( var i = 0; i < screenTones.length; i++ ) {
			bc.fillStyle = screenTones[ i ];
			bc.fillRect( i * 32, 0, 32, 32 );
		}
		alert( "screenTones" );
	}
	
	this.preloaded = true;	//メインのオブザーバーがこれを見ている。
	console.log( "effect ready" );

}


effect.start = function() {
/*
	この設定をすると、
	メインのframe()が、effect.frame()を実行した際、
	fadeの処理に入る。
*/
	this.fade = true;
	this.fadeCnt = 0;
}

effect.frame = function() {
/*
	エフェクトの描画を行う。
*/
	//エフェクト
	if( this.fade ) {
		//現在メイン画面ではなくなったほうを裏画面に描画
		this.beforeScene.frame( bc );
		
		//その裏画面をスクリーントーンでくりぬく（くりぬかれた部分は透明）
		bc.save();
			bc.globalCompositeOperation = "destination-in";	//パターンの透明部分で、元をくりぬく
			bc.fillStyle = screenTones[ screenTones.length - 1 - this.fadeCnt ];	//登録したものと逆順
			bc.fillRect( 0, 0, bc.canvas.width, bc.canvas.height );
		bc.restore();
		//その裏画面を表画面へ描画
		fc.drawImage( bc.canvas, 0, 0 );	//canvas自体をdrawImage()できるのが便利だ…
		
		this.fadeCnt++;
			//check.　エフェクトの終了
			if( this.fadeCnt == screenTones.length ) {
				this.fade = false;
			}
		
		//※エフェクトが終わると、メイン画面ではないほうの動きは停止。
	}
}


//スクリーントーンのテキストデータ
var screenToneData = [
	[//1
		"0000",
		"0000",
		"0000",
		"0000",
	],
	[//2
		"0000",
		"0000",
		"0000",
		"0010",
	],
	[//3
		"0000",
		"0000",
		"0000",
		"1010",
	],
	[//4
		"0000",
		"0000",
		"0001",
		"1010",
	],
	[//5
		"0001",
		"0000",
		"0001",
		"1010",
	],
	[//6
		"0001",
		"1000",
		"0001",
		"1010",
	],
	[//7
		"0001",
		"1010",
		"0001",
		"1010",
	],
	[//8
		"0001",
		"1010",
		"0101",
		"1010",
	],
	[//9
		"0101",
		"1010",
		"0101",
		"1010",
	],
	[//10
		"0101",
		"1010",
		"0101",
		"1110",
	],
	[//11
		"0101",
		"1011",
		"0101",
		"1110",
	],
	[//12
		"0101",
		"1011",
		"0101",
		"1111",
	],
	[//13
		"0101",
		"1111",
		"0101",
		"1111",
	],
	[//14
		"0101",
		"1111",
		"1101",
		"1111",
	],
	[//15
		"0111",
		"1111",
		"1101",
		"1111",
	],
	[//16
		"0111",
		"1111",
		"1111",
		"1111",
	],
];
